#pragma once

#include "resource.h"

class oGraphicsLoader
{
protected:
	oComPtr<IDirect3D8>::Type direct3d;

	ushort minVertexShaderVersion, minPixelShaderVersion;
	bool supportLegacyPixelPipeline;

	ulong adapter;
	bool hardwareVertexShaders, hardwarePixelShaders;
	bool windowed;
	uchar selectedHardwareUsage;
	D3DDISPLAYMODE selectedMode;
	
	const _TCHAR* CheckAdapter();
	void LoadAdapters(const HWND& dialog);
	void LoadHardwareOptions(const HWND& dialog) throw();

	struct IndexedDisplayMode { D3DDISPLAYMODE mode; ulong index; };
	static bool CompareMode(IndexedDisplayMode* mode1, IndexedDisplayMode* mode2) throw();
	void UpdateModes(const HWND& dialog);

	static oGraphicsLoader* GetGraphicsLoader(const HWND& dialog);
	static INT_PTR CALLBACK DialogProc(HWND dialog, UINT msg, WPARAM wParam, LPARAM lParam) throw();

public:
	oGraphicsLoader();

	IDirect3D8* const& GetDirect3D() const { return direct3d; }

	const ulong& GetSelectedAdapter() const throw() { return adapter; }
	const bool& IsSelectedWindowed() const throw() { return windowed; }
	const D3DDISPLAYMODE& GetSelectedMode() const throw() { return selectedMode; }
	const uchar& GetSelectedHardwareUsage() const throw() { return selectedHardwareUsage; }

	void SetMinVertexShaderVersion(const ushort& version) throw();
	void SetMinPixelShaderVersion(const ushort& version) throw();
	void SupportLegacyPixelPipeline(const bool& support) throw();

    bool Show(HINSTANCE instance);
};