#include "openengine.h"

oVertexShader::oVertexShader() throw() : handle(0), device(0) {}

oVertexShader::~oVertexShader() throw()
{
	Free();
}

void oVertexShader::Create(IDirect3DDevice8* const& device_, const ulong& handle_) throw()
{
	// store the vertex shader handle and creating device
	device = device_;
	device->AddRef();
	handle = handle_;
}

void oVertexShader::Free() throw()
{
	// release stuff
	if(device)
	{
		if(handle)
		{
			device->DeleteVertexShader(handle);
			handle = 0;
		}
		device->Release();
        device = 0;		
	}
}

oPixelShader::oPixelShader() throw() : handle(0), device(0) {}

oPixelShader::~oPixelShader() throw()
{
	Free();
}

void oPixelShader::Create(IDirect3DDevice8* const& device_, const ulong& handle_) throw()
{
	// store the vertex shader handle and creating device
	device = device_;
	device->AddRef();
	handle = handle_;
}

void oPixelShader::Free() throw()
{
	// release stuff
	if(device)
	{
		if(handle)
		{
			device->DeletePixelShader(handle);
			handle = 0;
		}
		device->Release();
        device = 0;		
	}
}
