#pragma once

class oRunnable
{
public:
	virtual uint Run() throw() = 0;
	virtual void Signal();
};

class oThread
{
protected:
	HANDLE handle;

	static uint __stdcall ThreadProc(void* object) throw();

public:
	oThread();
	~oThread() throw();

	void Start(oRunnable* const& object);
    void Wait(const ulong& timeout = INFINITE) throw();
};

class oEvent
{
protected:
	HANDLE handle;

public:
	oEvent();
	oEvent(const bool& manualReset);
	~oEvent() throw();

	void Signal();
	void Reset();
    void Wait(const ulong& timeout = INFINITE) throw();

	operator const HANDLE&() throw() { return handle; }
};